; Programme de compression
; Mettre dans file_length la longueur du fichier a compresser
; , dans file_name le nom du fichier a compresser, et enfin
; dans packedfile_name le nom du fichier compress.

file_length	equ	32000

;***********
Section DATA
;***********
file_name:
 dc.b		'a:1.img',0
packedfile_name:
 dc.b		'a:1.pak',0
 	
;***********
Section TEXT
;***********
main:
 movem.l	d0-d7/a0-a6,-(sp)
 movea.l	#bk_occurences,a0
 move.l	#fin_section_bss,d0
 sub.l		a0,d0
 move.b	#$ff,fin_section_bss
init_bss_section:		; On initialise section BSS.
 move.b	#$00,(a0)+	; On remplit avec des 0.
 dbra		d0,init_bss_section
allocation_memoire:
 move.l	#file_length+$2000,d0
 addi.l	#megabuffer,d0
 subi.l	#main,d0
 move.l	d0,-(sp)
 move.l	#main,-(sp)
 move.w	#0,-(sp)
 move.w	#$4a,-(sp)	; On reserve ce qu'il nous faut
 trap		#1		; a partir de main!
 add.l	#12,sp
chargement_fichier:		; On le met dans #megabuffer+$2000.
 move.w	#0,-(sp)
 move.l	#file_name,-(sp)
 move.w	#$3d,-(sp)	; Ouverture fichier en lecture.
 trap	#1
 addq.l	#$8,sp
 move.w	d0,d7		; Numero de canal.
 move.l	#megabuffer+$2000,-(sp)
 move.l	file_length,-(sp)
 move.w	d7,-(sp)
 move.w	#$3f,-(sp)	; Lecture du fichier.
 trap	#1
 add.l	#12,sp
 move.w	d7,-(sp)
 move.w	#$3e,-(sp)	; Fermeture du fichier.
 trap	#1
 addq.l	#4,sp

;****************
occurences_table:		;construction table des occurences.
 move.l	#megabuffer+$2000,a0
 move.l	#bk_occurences,a1
 move.l	#file_length,d0
 subi.l	#1,d0	
count_each_byte:
 move.l	a1,a2
 adda.l	(a0)+,a2
 addi.l	#1,(a2)
 dbra		d0,count_each_byte 	
	

fin_prog:
 movem.l	(sp)+,d0-d7/a0-a6
 clr.w		-(sp)
 trap		#1




;**********
Section BSS
;**********
bk_occurences:		; Occurences des bytes et knots.
 ds.l		512		
knots:				; Upperword: byte ou knot fort.
 ds.l		256		; Lowerword: byte ou knot faible.
bk_min:			; Index du byte ou knot de plus
 ds.w		1		; faible occurence.
bk_max:			; Index du byte ou knot de plus
 ds.w		1		; forte occurence.
knot_index:			; Knot courant.
 ds.w		1
fin_section_bss:
 ds.b		1
megabuffer:			; Megabuffer,qui contient les donnees.
 ds.l		1		
