 move.l	#$ffff,a6
repeat:
 move.w	#$1,d0
 move.w	#$1,d1
 move.w	#$40,d2
 move.w	#$20,d3
 move.l	#$f8000,a0
 move.l	#$f0000,a3
 move.l	#$0,a4
 jsr	fastline

 move.l	#$f0000,a0
 move.l	a0,a1
 move.l	a4,d7
 move.l	d7,d6
 andi.l	#$3,d7
 sub.l	d7,d6
 beq.s	fin_repeat_1
 add.l	d6,d6
 add.l	d6,a1
 move.l	#$100000,d5
repeat_1:
 movem.w	(a0)+,a2-a5
 add.l	d5,a2
 move.w	d5,(a2)
 add.l	d5,a3
 move.w	d5,(a3)
 add.l	d5,a4
 move.w	d5,(a4)
 add.l	d5,a5
 move.w	d5,(a5)
 cmp.l	a0,a1
 bne.s	repeat_1
fin_repeat_1
 subq.l	#$1,d7
 bmi.s	next
repeat_2:
 move.w	(a0)+,a2
 add.l	d5,a2
 move.w	d5,(a2)
 dbra	d7,repeat_2



next:
 subq.l	#$1,a6
 cmp.l	#$0,a6
 bne	repeat

 clr.w	-(sp)
 trap	#1
 	



;****************************
; Line Routine en 1 bitplan.
;****************************
; Appel:
;   d0.w = x1.
;   d1.w = y1.
;   d2.w = x2.
;   d3.w = y2.
;   a0.l = adresse ramvideo.
;   a3.l = adresse sauvegarde.
; Sortie:
;   Ligne affichee (encore heureux!).
;   a4.l = a4.l + nbr mots modifies.
; Utilise:
;   d0-d7/a0-a4.

fastline:
 sub.w	d0,d2	; d2=dx=x2-x1.
 beq	v_line	; Ligne verticale?
 bmi.s	dxneg	; On cherche a voir x1>x2,
 add.w	d2,d0	; quitte a changer l'ordre
 exg.l	d1,d3	; des points.
 neg.w	d2	; Deux negations pour avoir dx positif.
dxneg:
 neg.w	d2	; Ici d2=dx est positif.
 sub.w	d1,d3	; d3=dy=y2-y1.
 beq	h_line	; Ligne horizontale?
 bmi	dyneg	; On calcule le signe de dy,

dypos:
 move.l	#$a0,a2	; a2=increment pour y.
 move.w	d0,d4	; Dans d4 et dans d5 on calcule les
 move.w	d1,d5	; x et y de la deuxieme partie.
 lsr.w	#$1,d2	; d2=int(dx/2).
 beq	low_dx	; Si d2=0 alors on avait dx=1.
 bcc.s	pos_midx	; On regarde le bit shifte. Si c=1 la 2eme
 subq.w	#$1,d4	; partie commence apres le milieu de la ligne,
pos_midx:		; sinon elle commence exactement au milieu.
 sub.w	d2,d4	; xmid=x1-int(dx/2) (-1).
 lsr.w	#$1,d3	; On effectue les memes operations pour dy.
 bcc.s	pos_midy	; Retenue a 1?
 addq.w	#$1,d5	; Alors ymid=y1+int(dy/2)+1.
pos_midy:		; Sinon on a:
 add.w	d3,d5	; ymid=y1+int(dy/2).
 bra.s	convert

dyneg:
 move.l	#-$a0,a2	; a2=increment pour y.
 neg.w	d3	; On force dy a une valeur >0.
 move.w	d0,d4	; Dans d4 et dans d5 on calcule les
 move.w	d1,d5	; x et y de la deuxieme partie.
 lsr.w	#$1,d2	; d2=int(dx/2).
 beq	low_dx	; Si d2=0 alors on avait dx=1.
 bcc.s	neg_midx	; On regarde le bit shifte. Si c=1 la 2eme
 subq.w	#$1,d4	; partie commence apres le milieu de la ligne,
neg_midx:		; sinon elle commence exactement au milieu.
 sub.w	d2,d4	; xmid=x1-int(dx/2) (-1).
 lsr.w	#$1,d3	; On effectue les memes operations pour dy.
 bcc.s	neg_midy	; Retenue a 1?
 subq.w	#$1,d5	; Alors ymid=y1-int(dy/2)-1.
neg_midy:		; Sinon on a:
 sub.w	d3,d5	; ymid=y1-int(dy/2).

convert:		; On convertit ensuite les coordonnees
 move.l	a0,a1	; en adresse et motifs.
 move.w	d1,d6	; Multiplication de y1 par 160.	
 lsl.w	#$2,d1
 add.w	d6,d1
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur la ligne y1.
 move.w	d5,d6	; Multiplication de ymid par 160.
 lsl.w	#$2,d5
 add.w	d6,d5
 lsl.w	#$5,d5
 add.w	d5,a1	; a1 pointe sur la ligne ymid.

 moveq.l	#$f,d6	; Il faut convertir les x en tenant compte
 move.w	d0,d1	; de la structure de la ramvideo.
 and.w	d6,d0	; d0=x1 mod(16).
 sub.w	d0,d1	; d1=x1-x1 mod(16).
 lsr.w	#$1,d1	; d1=nbr de mots avant le point.
 add.w	d1,a0	; a0 pointe sur le bon mot.
 sub.w	d6,d0	; d0=15-x1 mod(16) pour savoir sur quel
 neg.w	d0	; bit placer le point. (le shifter lit
 moveq.l	#$0,d1	; les mot en commencant par les upperbits)
 bset.l	d0,d1	; d1 contient le motif de x1.

 move.w	d4,d5	; On fait la meme chose pour xmid.	
 and.w	d6,d4	
 sub.w	d4,d5
 lsr.w	#$1,d5
 add.w	d5,a1
 sub.w	d6,d4
 neg.w	d4
 moveq.l	#$0,d5
 bset.l	d4,d5	; d5 contient le motif de xmid.

calcul_slope:
 cmp.w	d3,d2	; Pente forte ou faible?
 bmi	big_slope

;***********************
; dx>=dy, Pente faible.
;***********************

low_slope:
 move.w	d2,d7	; d7=dx=nbre de points.
 add.w	d3,d3	; d3=2*dy.
 move.w	d3,d6	; d6 utilise comme erreur.
 sub.w	d2,d6	; Err=2*dy-dx au depart.
 add.w	d2,d2	; d2=2*dx.
 move.w	(a0),d0	; On prend les mots sur lequels on travaile.
 move.w	(a1),d4
 or.w	d1,d0	; Et on affiche les premiers points.
 or.w	d5,d4
 subq.w	#$1,d7	; Il reste donc un point de moins.

low_line:
 tst.w	d6	; Erreur positive?
 bgt.s	low_epos	; Si oui y suivant.
low_eneg:		; Sinon x suivant.
 add.w	d3,d6	; Err=Err+2*dy.
 add.w	d1,d1	; Motif du point suivant (1ere moitie).
 beq.s	low_xnul1	; Doit on changer de mot?
 add.w	d5,d5	; Motif du point suivant (2eme moitie).
 beq.s	low_xnul2	; Doit on changer de mot?
low_plot:
 or.w	d1,d0	; Affichage des points dans les
 or.w	d5,d4	; registres de travail.
 dbra	d7,low_line	; Point suivant.
 move.w	d0,(a0)	; Affichage des dernier points.
 move.w	d4,(a1)
 move.w	a0,(a3)+	; Sauvegarde des adresses des mots
 move.w	a1,(a3)+	; qui sont modifies.
 addq.l	#$2,a4	; On compte les deux modifs.
 rts		; Ligne affichee.

low_epos:
 sub.w	d2,d6	; Err=Err-2*dx.
 move.w	d0,(a0)	; Affichage des points.
 move.w	d4,(a1)
 move.w	a0,(a3)+	; Sauvegarde des adresses des mots
 move.w	a1,(a3)+	; qui sont modifies.
 addq.l	#$2,a4	; On compte les deux modifs.
 add.l	a2,a0	; y1=y1+sy.
 add.l	a2,a1	; ymid=ymid+sy.
 move.w	(a0),d0	; Nouveaux mots de travail.
 move.w	(a1),d4
low_eneg2:		; Le point suivant est sur x.
 add.w	d3,d6	; Err=Err+2*dy.
 add.w	d1,d1	; Motif du point suivant (1ere moitie).
 beq.s	low_xnul3	; Doit on changer de mot?
 add.w	d5,d5	; Motif du point suivant (2eme moitie).
 beq.s	low_xnul4	; Doit on changer de mot?
low_plot2:
 or.w	d1,d0	; Affichage des points dans les
 or.w	d5,d4	; registres de travail.
 dbra	d7,low_line	; Point suivant.
 move.w	d0,(a0)	; Affichage des dernier points.
 move.w	d4,(a1)
 move.w	a0,(a3)+	; Sauvegarde des adresses des mots
 move.w	a1,(a3)+	; qui sont modifies.
 addq.l	#$2,a4	; On compte les deux modifs.
 rts		; Ligne affichee.

low_xnul1:		; On doit passer au mot suivant pour x1.
 move.w	d0,(a0)	; Affichage dans ramvideo.
 move.w	a0,(a3)+	; Sauvegarde de l'adresse.
 addq.l	#$1,a4	; Une modif de plus.
 moveq.l	#$1,d1	; Motif du premier point.
 subq.l	#$8,a0	; Mot precedent.
 move.w	(a0),d0	; Qui est le mot de travail.
 add.w	d5,d5	; Motif du point suivant (2eme moitie).
 beq.s	low_xnul2	; Doit on changer de mot?
low_plot3:
 or.w	d1,d0	; Affichage des points dans les
 or.w	d5,d4	; registres de travail.
 dbra	d7,low_line	; Point suivant.
 move.w	d0,(a0)	; Affichage des dernier points.
 move.w	d4,(a1)
 move.w	a0,(a3)+	; Sauvegarde des adresses des mots
 move.w	a1,(a3)+	; qui sont modifies.
 addq.l	#$2,a4	; On compte les deux modifs.
 rts		; Ligne affichee.

low_xnul2:		; On doit passer au mot suivant pour xmid.
 move.w	d4,(a1)	; Affichage dans ramvideo.
 move.w	a1,(a3)+	; Sauvegarde de l'adresse.
 addq.l	#$1,a4	; Une modif de plus.
 moveq.l	#$1,d5	; Motif du premier point.
 subq.l	#$8,a1	; Mot precedent.
 move.w	(a1),d4	; Qui est le mot de travail.
low_plot4:
 or.w	d1,d0	; Affichage des points dans les
 or.w	d5,d4	; registres de travail.
 dbra	d7,low_line	; Point suivant.
 move.w	d0,(a0)	; Affichage des dernier points.
 move.w	d4,(a1)
 move.w	a0,(a3)+	; Sauvegarde des adresses des mots
 move.w	a1,(a3)+	; qui sont modifies.
 addq.l	#$2,a4	; On compte les deux modifs.
 rts		; Ligne affichee.

low_xnul3:		; On vient de changer de y1, mais on doit
 moveq.l	#$1,d1	; changer de mot sans avoir rien affiche.
 subq.l	#$8,a0	; Mot precedent.
 move.w	(a0),d0	; Qui est le nouveau mot de travail.
 add.w	d5,d5	; Motif du point suivant (2eme moitie).
 beq.s	low_xnul4	; Doit on changer de mot?
low_plot5:
 or.w	d1,d0	; Affichage des points dans les
 or.w	d5,d4	; registres de travail.
 dbra	d7,low_line	; Point suivant.
 move.w	d0,(a0)	; Affichage des dernier points.
 move.w	d4,(a1)
 move.w	a0,(a3)+	; Sauvegarde des adresses des mots
 move.w	a1,(a3)+	; qui sont modifies.
 addq.l	#$2,a4	; On compte les deux modifs.
 rts		; Ligne affichee.

low_xnul4:		; On vient de changer de ymid, mais on doit
 moveq.l	#$1,d5	; changer de mot sans avoir rien affiche.
 subq.l	#$8,a1	; Mot precedent.
 move.w	(a1),d4	; Qui est le nouveau mot de travail.
low_plot6:
 or.w	d1,d0	; Affichage des points dans les
 or.w	d5,d4	; registres de travail.
 dbra	d7,low_line	; Point suivant.
 move.w	d0,(a0)	; Affichage des dernier points.
 move.w	d4,(a1)
 move.w	a0,(a3)+	; Sauvegarde des adresses des mots
 move.w	a1,(a3)+	; qui sont modifies.
 addq.l	#$2,a4	; On compte les deux modifs.
 rts		; Ligne affichee.

;*********************
; dy>dx, Pente forte.
;*********************

big_slope:
 move.w	d3,d7	; d7=dy=nbre de points.
 add.w	d2,d2	; d2=2*dx.
 move.w	d2,d6	; d6 utilise comme erreur.
 sub.w	d3,d6	; Err=2*dx-dy au depart.
 add.w	d3,d3	; d2=2*dy.

 and.l	#$ffff,d3	; Un point=2 mots changes, et nbr points
 add.l	d3,a4	; vaut 2*dy+2 dans le cas d'une
 addq.l	#$2,a4	; pente forte.

 or.w	d1,(a0)	; Affichage des premiers points.
 or.w	d5,(a1)
 move.w	a0,(a3)+	; On sauve les adresses des mots modifies.
 move.w	a1,(a3)+
 subq.w	#$1,d7	; Un point de moins a afficher.

big_line:
 tst.w	d6	; Erreur positive?
 bgt.s	big_epos	; Si oui x suivant.
big_eneg:		; Sinon y suivant.
 add.w	d2,d6	; Err=Err+2*dx.
 add.w	a2,a0	; y1=y1+sy.
 add.w	a2,a1	; ymid=ymid+sy.
big_plot:
 or.w	d1,(a0)	; Affichage des points.
 or.w	d5,(a1)
 move.w	a0,(a3)+	; Sauvegarde des adresses.
 move.w	a1,(a3)+
 dbra	d7,big_line	; Point suivant.
 rts

big_epos:
 sub.w	d3,d6	; Err=Err-2*dy.
 add.w	d1,d1	; Motif du point suivant (1ere moitie).
 beq.s	big_xnul1	; Doit on changer de mot?
 add.w	d5,d5	; Motif du point suivant (2eme moitie).
 beq.s	big_xnul2	; Doit on changer de mot?
big_eneg2:		; Le point suivant est sur y.
 add.w	d2,d6	; Err=Err+2*dx.
 add.w	a2,a0	; y1=y1+sy.
 add.w	a2,a1	; ymid=ymid+sy.
big_plot2:
 or.w	d1,(a0)	; Affichage des points.
 or.w	d5,(a1)
 move.w	a0,(a3)+	; Sauvegarde des adresses.
 move.w	a1,(a3)+
 dbra	d7,big_line	; Point suivant.
 rts

big_xnul1:		; On doit passer au mot suivant pour x1.
 moveq.l	#$1,d1	; Motif du premier point.
 subq.l	#$8,a0	; Mot precedent.
 add.w	d5,d5	; Motif du point suivant (2eme moitie).
 beq.s	big_xnul2	; Doit on changer de mot?
big_eneg3:		; Le point suivant est sur y.
 add.w	d2,d6	; Err=Err+2*dx.
 add.w	a2,a0	; y1=y1+sy.
 add.w	a2,a1	; ymid=ymid+sy.
big_plot3:
 or.w	d1,(a0)	; Affichage des points.
 or.w	d5,(a1)
 move.w	a0,(a3)+	; Sauvegarde des adresses.
 move.w	a1,(a3)+
 dbra	d7,big_line	; Point suivant.
 rts

big_xnul2:		; On doit passer au mot suivant pour xmid.
 moveq.l	#$1,d5	; Motif du premier point.
 subq.l	#$8,a1	; Mot precedent.
big_eneg4:		; Le point suivant est sur y.
 add.w	d2,d6	; Err=Err+2*dx.
 add.w	a2,a0	; y1=y1+sy.
 add.w	a2,a1	; ymid=ymid+sy.
big_plot4:
 or.w	d1,(a0)	; Affichage des points.
 or.w	d5,(a1)
 move.w	a0,(a3)+	; Sauvegarde des adresses.
 move.w	a1,(a3)+
 dbra	d7,big_line	; Point suivant.
 rts

;*******************************************************
; dx=1, Ligne speciale: deux lignes verticales aposees.
;*******************************************************

low_dx:
 addq.l	#$1,d3	; On va compter le nombre de y qu'il
 move.w	d3,d2	; faut avant de changer de x.
 lsr.w	#$1,d2	; d2=int((y2-y1+1)/2).
 add.l	d3,a4	; Nbr de mots que l'on va changer.
 sub.w	d2,d3

dx_convert:		; On convertit ensuite les coordonnees.
 move.w	d1,d6	; Multiplication de y1 par 160.	
 lsl.w	#$2,d1
 add.w	d6,d1
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur la ligne y1.

 moveq.l	#$f,d6	; Il faut convertir les x en tenant compte
 move.w	d0,d1	; de la structure de la ramvideo.
 and.w	d6,d0	; d0=x1 mod(16).
 sub.w	d0,d1	; d1=x1-x1 mod(16).
 lsr.w	#$1,d1	; d1=nbr de mots avant le point.
 add.l	d1,a0	; a0 pointe sur le bon mot.
 sub.w	d6,d0	; d0=15-x1 mod(16) pour savoir sur quel
 neg.w	d0	; bit placer le point. (le shifter lit
 moveq.l	#$0,d1	; les mot en commencant par les upperbits)
 bset.l	d0,d1	; d1 contient le motif de x1.

 subq.l	#$1,d2	; A cause du dbra.
line1:
 or.w	d1,(a0)	; On affiche un point.
 move.w	a0,(a3)+	; Et on sauve l'adresse.
 add.l	a2,a0	; Point suivant.
 dbra	d2,line1

 add.w	d1,d1	; Motif suivant.
 bne.s	motif_ok	; Faut-il changer de motif?
 moveq.l	#$1,d1	; changer de mot sans avoir rien affiche.
 subq.l	#$8,a0	; Mot precedent.

motif_ok:
 subq.l	#$1,d3	; A cause du dbra.
line2:
 or.w	d1,(a0)	; On affiche un point.
 move.w	a0,(a3)+	; Et on sauve l'adresse.
 add.l	a2,a0	; Point suivant.
 dbra	d3,line2
 rts


;*************************
; x1=x2  Ligne Verticale.
;*************************

v_line:
 move.l	#$a0,d4	; d4=sy.
 sub.w	d1,d3	; d3=dy.
 beq.s	single_dot	; Si dy=0 on a un point.
 bge.s	v_dypos	; Si dy>0 tout est ok.
 neg.l	d4	; Sinon on doit changer le signe de d4,
 neg.w	d3	; et prendre abs(dy).
v_dypos:
 move.w	d1,d5	; Multiplication de y1 par 160.
 lsl.w	#$2,d1
 add.w	d5,d1
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur le debut de la ligne.
 move.w	d0,d1	; Ensuite on recherche le mot de depart.
 andi.w	#$fff0,d1	; d1=x-x mod(16).
 sub.w	d1,d0	; d0=x mod(16).
 lsr.w	#$1,d1	; nbre de mots avant le x courant.
 add.w	d1,a0	; a0 point sur le bon mot.
 sub.w	#$f,d0	; On prend maintenant 15-x dans d0, car le
 neg.w	d0	; shifter lit d'abord les bits de poid fort.
 moveq.l	#$0,d1	; d1 va contenir le motif.
 bset.l	d0,d1	; Il le contient!

 andi.l	#$ffff,d3	; On clear le upperword.
 add.l	d3,a4 	; Nbre de mots modifies.
 addq.l	#$1,a4	; car dy=nbr mots -1.
v_one_line:
 or.w	d1,(a0)	; On affiche le motif.
 move.w	a0,(a3)+	; On sauve l'adresse.
 add.w	d4,a0	; Ligne suivante ou precedente.
 dbra	d3,v_one_line
 rts		; Fin de la ligne.

single_dot:
 move.w	d1,d5	; Multiplication de y1 par 160.
 lsl.w	#$2,d1
 add.w	d5,d1
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur le debut de la ligne.
 move.w	d0,d1	; Ensuite on recherche le mot de depart.
 andi.w	#$fff0,d1	; d1=x-x mod(16).
 sub.w	d1,d0	; d0=x mod(16).
 lsr.w	#$1,d1	; nbre de mots avant le x courant.
 add.w	d1,a0	; a0 point sur le bon mot.
 sub.w	#$f,d0	; On prend maintenant 15-x dans d0, car le
 neg.w	d0	; shifter lit d'abord les bits de poid fort.
 moveq.l	#$0,d1	; d1 va contenir le motif.
 bset.l	d0,d1	; Il le contient!
 or.w	d1,(a0)	; Affichage du motif.
 move.w	a0,(a3)+	; On sauve l'adresse.
 addq.l	#$1,a4	; Et un mot de plus.
 rts		; Fin de la ligne.


;***************************
; y1=y2  Ligne Horizontale.
;***************************

h_line:
 sub.w	d2,d0	; On retrouve x1.
 add.w	d0,d2	; Puis on retrouve x2.
 move.w	d1,d5	; Multiplication de y1 par 160.
 lsl.w	#$2,d1
 add.w	d5,d1
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur le debut de la ligne.

 moveq.l	#$0f,d4	; d4 sert pour les and.
 move.w	d0,d1	; Maintenant on va rechercher l'adresse de
 move.w	d2,d3	; depart ainsi que les motifs.
 and.w	d4,d0	; d0=x1 mod(16).
 and.w	d4,d2	; d2=x2 mod(16).
 sub.w	d0,d1	; d1=x1-x1 mod(16).
 sub.w	d2,d3	; d3=x2-x2 mod(16).
 lsr.w	#$1,d1	; d1=nbr de bytes avant motif de depart.
 lsr.w	#$1,d3	; d1=nbr de bytes avant motif d'arrivee.
 add.w	d1,a0	; a0 pointe sur le mot de depart.
calc_motifs:
 add.w	d0,d0	; Un motif tient sur un mot.
 add.w	d2,d2	; On va avoir le motif de depart dans d0
 move.l	#motifs,a1	; et celui d'arrivee dans d2.
 move.w	(a1,d0.w),d0
 move.w	(a1,d2.w),d2
 not.w	d0	; Inverser d2.
 add.w	d0,d0	; Et le shifter a gauche
 addq.w	#$1,d0	; tout en remplissant la droite.

 sub.w	d1,d3	; Nombre de mots a afficher.
 beq.s	h_melted
 lsr.w	#$3,d3	; On utilise un seul bitplan.

 move.l	#$ffff,d5	; Motif de remplissage.
 and.l	d5,d3	; Nbre de mots modifies moins un.
 add.l	d3,a4	; On les comptabilises.
 addq.l	#$1,a4	; Tous!

 subq.w	#$2,d3	; Les mots extremes sont traites differement.
 bmi.s	h_near
h_far:
 or.w	d0,(a0)	; Affichage du motif droit.
 move.w	a0,(a3)+	; Sauvegarde de l'adresse.
 addq.l	#$8,a0	; Mot suivant.
h_fill:
 move.w	d5,(a0)	
 move.w	a0,(a3)+	; Sauvegarde de l'adresse.
 addq.l	#$8,a0	; Mot suivant.
 dbra	d3,h_fill
 or.w	d2,(a0)	; Affichage du motif droit.
 move.w	a0,(a3)+	; Sauvegarde de l'adresse.
 rts		; Fin de la ligne.

h_melted:
 and.w	d0,d2	; Motifs melanges.
 or.w	d2,(a0)	; affichage du motif.
 addq.l	#$1,a4	; Un mot de plus.
 move.w	a0,(a3)+	; Sauvegarde de l'adresse.
 rts		; Fin de la ligne.

h_near:
 or.w	d0,(a0)	; Affichage du motif droit.
 move.w	a0,(a3)+	; Sauvegarde de l'adresse.
 addq.l	#$8,a0	; Mot suivant.
 or.w	d2,(a0)	; Affichage du motif droit.
 move.w	a0,(a3)+	; Sauvegarde de l'adresse.
 rts		; Fin de la ligne.


motifs:
 dc.w	%1000000000000000
 dc.w	%1100000000000000
 dc.w	%1110000000000000
 dc.w	%1111000000000000
 dc.w	%1111100000000000
 dc.w	%1111110000000000
 dc.w	%1111111000000000
 dc.w	%1111111100000000
 dc.w	%1111111110000000
 dc.w	%1111111111000000
 dc.w	%1111111111100000
 dc.w	%1111111111110000
 dc.w	%1111111111111000
 dc.w	%1111111111111100
 dc.w	%1111111111111110
 dc.w	%1111111111111111
