;  opt	o+
size_y	equ	64

main:
  move.l	#$0,-(sp)	; Fuck the Atari fellow who said the color
  move.w	#$20,-(sp)	; palette could only be changed in
  trap	#$1	; supervisor mode....
  addq.l	#$6,sp

.change_colors:		; Gem colors are Beurk....
  move.w	#$8240,a0
  move.l	#gem_colors,a1
  move.l	#morph_colors,a2
 rept	8
  move.l	(a0),(a1)+
  move.l	(a2)+,(a0)+
 endr

  move.w	#$25,-(sp)
  trap	#$1	; Vsync.
  addq.l	#$2,sp
  move.w	$ffff8260.w,gem_res
  move.b	#$0,$ffff8260.w

black_to_image1:
  move.l	#black_image,a0
  move.l	#morph_images,a1
  move.l	#linear_image,a2
  move.l	#increments,a3
  jsr	prepare_morph

  move.w	#15,d7	; 16 stages for the morphing.
.one_stage:
  move.w	#$25,-(sp)
  trap	#$1	; Vsync.
  addq.l	#$2,sp

  move.l	#$f8000,a0
  move.l	#linear_image,a1
  move.l	#increments,a2
  jsr	morph_it
  dbra	d7,.one_stage

image1_to_image2:
  move.l	#morph_images,a0
  move.l	#morph_images+(48*size_y),a1
  move.l	#linear_image,a2
  move.l	#increments,a3
  jsr	prepare_morph

  move.w	#15,d7	; 16 stages for the morphing.
.one_stage:
  move.w	#$25,-(sp)
  trap	#$1	; Vsync.
  addq.l	#$2,sp

  move.l	#$f8000,a0
  move.l	#linear_image,a1
  move.l	#increments,a2
  jsr	morph_it
  dbra	d7,.one_stage

image1_to_black:
  move.l	#morph_images+(48*size_y),a0
  move.l	#black_image,a1
  move.l	#linear_image,a2
  move.l	#increments,a3
  jsr	prepare_morph

  move.w	#15,d7	; 16 stages for the morphing.
.one_stage:
  move.w	#$25,-(sp)
  trap	#$1	; Vsync.
  addq.l	#$2,sp

  move.l	#$f8000,a0
  move.l	#linear_image,a1
  move.l	#increments,a2
  jsr	morph_it
  dbra	d7,.one_stage

  move.w	#$25,-(sp)
  trap	#$1	; Vsync.
  addq.l	#$2,sp
  move.w	gem_res,$ffff8260.w

.restore_colors:	; They are still Beurk....
  move.l	#gem_colors,a0
  move.w	#$8240,a1
 rept	8
  move.l	(a0)+,(a1)+
 endr

the_end:
  clr.w	-(sp)
  trap	#$1

;**************************************************************************
;**************************************************************************
; Routine which morphs the current image and convert it into planar mode.
;**************************************************************************
;**************************************************************************
; Parameters:	a0.l = adress of the ramvideo.
;	a1.l = adress of the source image.
;	a2.l = adress of the increments.
; The image is supposed to be a 96*64 pixies one.
; The adress of the ramvideo must be so that it points on
; the good y line.

morph_it:
  movem.l	d0-d6/a0-a2,-(sp) ; Hummm...
  add.w	#56,a0	; We want to be on the middle, no?
  move.l	#size_y-1,d6	; Nb of lines to convert.
.one_line:
 rept	16	; Blocks of 16 pixels in planar mode.
  move.b	(a1),d0	; The pixie is now in d0.
  move.b	(a2)+,d1	; The increment in d1.
  add.b	d0,d1	; This is the morphing...
  move.b	d1,(a1)+	; Well, save the new pixie.
; The image is 1 pixie=1 byte lookalike ( Linear. ), so I must convert
; each pixie into its bitplane representation.
  add.b	d0,d0	; Put the 1st bit of the pixie in the Carry.
  addx.w	d5,d5	; Add it in the word for bpl1.
  add.b	d0,d0	; 2nd bit in the carry.
  addx.w	d4,d4	; Put it in bpl2.
  add.b	d0,d0	; And so on for bpl 3.
  addx.w	d3,d3
  add.b	d0,d0	; Bpl 4.
  addx.w	d2,d2
 endr
  movem.w	d2-d5,(a0)	; Store the planar representation.
  addq.w	#$8,a0	; It could be made with a movem -(a0).

; A line is 96 pixies wide, so there are 6 blocks of 16 pixels.
; So the following is a mere repetition of the things above, and
; it' s repeted three times.

 rept	16	
  move.b	(a1),d0	
  move.b	(a2)+,d1	
  add.b	d0,d1	
  move.b	d1,(a1)+	
  add.b	d0,d0	
  addx.w	d5,d5	
  add.b	d0,d0	
  addx.w	d4,d4	
  add.b	d0,d0	
  addx.w	d3,d3
  add.b	d0,d0
  addx.w	d2,d2
 endr
  movem.w	d2-d5,(a0)	
  addq.w	#$8,a0	

 rept	16	
  move.b	(a1),d0	
  move.b	(a2)+,d1	
  add.b	d0,d1	
  move.b	d1,(a1)+	
  add.b	d0,d0	
  addx.w	d5,d5	
  add.b	d0,d0	
  addx.w	d4,d4	
  add.b	d0,d0	
  addx.w	d3,d3
  add.b	d0,d0
  addx.w	d2,d2
 endr
  movem.w	d2-d5,(a0)	
  addq.w	#$8,a0	

 rept	16	
  move.b	(a1),d0	
  move.b	(a2)+,d1	
  add.b	d0,d1	
  move.b	d1,(a1)+	
  add.b	d0,d0	
  addx.w	d5,d5	
  add.b	d0,d0	
  addx.w	d4,d4	
  add.b	d0,d0	
  addx.w	d3,d3
  add.b	d0,d0
  addx.w	d2,d2
 endr
  movem.w	d2-d5,(a0)	
  addq.w	#$8,a0	

 rept	16	
  move.b	(a1),d0	
  move.b	(a2)+,d1	
  add.b	d0,d1	
  move.b	d1,(a1)+	
  add.b	d0,d0	
  addx.w	d5,d5	
  add.b	d0,d0	
  addx.w	d4,d4	
  add.b	d0,d0	
  addx.w	d3,d3
  add.b	d0,d0
  addx.w	d2,d2
 endr
  movem.w	d2-d5,(a0)	
  addq.w	#$8,a0	

 rept	16	
  move.b	(a1),d0	
  move.b	(a2)+,d1	
  add.b	d0,d1	
  move.b	d1,(a1)+	
  add.b	d0,d0	
  addx.w	d5,d5	
  add.b	d0,d0	
  addx.w	d4,d4	
  add.b	d0,d0	
  addx.w	d3,d3
  add.b	d0,d0
  addx.w	d2,d2
 endr
  movem.w	d2-d5,(a0)	
  add.w	#120,a0

  dbra	d6,.one_line	; Next line.
  movem.l	(sp)+,d0-d6/a0-a2 ; That's all folks.
  rts
;**************************************************************************

;**************************************************************************
;**************************************************************************
;         Routine which prepare the image and the increment table.
;**************************************************************************
;**************************************************************************
; Parameters:	a0.l = adress of source for morphing.
;	a1.l = adress of destination for morphing.
;	a2.l = adress of the linear source image.
;	a3.l = adress of the increment table.
; The image is supposed to be a 96*64 pixies one.
; The source for morphing is converted in linear mode, with the value which
; is between 0-15 in the 4 most significant bits (MSB) of the pixie. The 4
; less significant bits (LSB) which is approximately the "regular" part of
; the color value ( this mean the part of the number after the dot.) are
; set to %0111, because if the increment is %00000001 the color change must
; happen after 8 iterations. With 0 in the regular part at the begining,
; the color change will be crappy.

prepare_morph:
  movem.l	d0-d6/a0-a4,-(sp) ; Yeah.
  move.w	#size_y-1,d5
  move.l	a2,a4
; At first we convert the source image into a linear mode.
.one_line:
  movem.w	(a0)+,d0-d3	; Load the 4 bitplanes.
 rept	16
  add.w	d3,d3	; Put the bit of bpl1 in the carry.
  addx.b	d4,d4	; It' s the first bit of the pixie.
  add.w	d2,d2	; Go on with bpl2.
  addx.b	d4,d4
  add.w	d1,d1	; Bpl 3.
  addx.b	d4,d4
  add.w	d0,d0	; Bpl 4.
  addx.b	d4,d4
  lsl.b	#$4,d4	; The value of the pixie in the 4 MSB.
  add.w	#%111,d4	; The value is now ?.5.
  move.b	d4,(a4)+	; Store the pixie.
 endr

; Again we have repetitions.... I assume you don' t need more explanations.
; Sorry if I'm not clear..

  movem.w	(a0)+,d0-d3
 rept	16
  add.w	d3,d3
  addx.b	d4,d4
  add.w	d2,d2
  addx.b	d4,d4
  add.w	d1,d1
  addx.b	d4,d4
  add.w	d0,d0	
  addx.b	d4,d4
  lsl.b	#$4,d4	
  add.w	#%111,d4	
  move.b	d4,(a4)+
 endr

  movem.w	(a0)+,d0-d3
 rept	16
  add.w	d3,d3
  addx.b	d4,d4
  add.w	d2,d2
  addx.b	d4,d4
  add.w	d1,d1
  addx.b	d4,d4
  add.w	d0,d0	
  addx.b	d4,d4
  lsl.b	#$4,d4	
  add.w	#%111,d4	
  move.b	d4,(a4)+
 endr

  movem.w	(a0)+,d0-d3
 rept	16
  add.w	d3,d3
  addx.b	d4,d4
  add.w	d2,d2
  addx.b	d4,d4
  add.w	d1,d1
  addx.b	d4,d4
  add.w	d0,d0	
  addx.b	d4,d4
  lsl.b	#$4,d4	
  add.w	#%111,d4	
  move.b	d4,(a4)+
 endr

  movem.w	(a0)+,d0-d3
 rept	16
  add.w	d3,d3
  addx.b	d4,d4
  add.w	d2,d2
  addx.b	d4,d4
  add.w	d1,d1
  addx.b	d4,d4
  add.w	d0,d0	
  addx.b	d4,d4
  lsl.b	#$4,d4	
  add.w	#%111,d4	
  move.b	d4,(a4)+
 endr

  movem.w	(a0)+,d0-d3
 rept	16
  add.w	d3,d3
  addx.b	d4,d4
  add.w	d2,d2
  addx.b	d4,d4
  add.w	d1,d1
  addx.b	d4,d4
  add.w	d0,d0	
  addx.b	d4,d4
  lsl.b	#$4,d4	
  add.w	#%111,d4	
  move.b	d4,(a4)+
 endr

  dbra	d5,.one_line	; Ok, we have converted one line.

; After this, we must calculate the increments for each pixie.
; In the same way, we convert the pixie of the destination, and
; then the increment is color of dest-color of source.

  move.w	#size_y-1,d6
.one_line2:
  movem.w	(a1)+,d0-d3	; Load the 4 bitplanes.
 rept	16
  add.w	d3,d3	; Put the bit of bpl1 in the carry.
  addx.b	d4,d4	; It' s the first bit of the pixie.
  add.w	d2,d2	; Go on with bpl2.
  addx.b	d4,d4
  add.w	d1,d1	; Bpl 3.
  addx.b	d4,d4
  add.w	d0,d0	; Bpl 4.
  addx.b	d4,d4
  and.w	#$f,d4	; In case of shitty bits.
  move.b	(a2)+,d5	; Load the source pixie.
  lsr.b	#$4,d5	; Don' t care about the regular part.
  sub.b	d5,d4	; Dest color-source col.
  move.b	d4,(a3)+	; Store the increment.
 endr

; I hope you are not angry with all this, but Devpac does not allow us
; to put a rept structure in another rept structure, so we have to copy
; it stupidely. Anyway Devpac is greeeeeeat.

  movem.w	(a1)+,d0-d3
 rept	16
  add.w	d3,d3	
  addx.b	d4,d4	
  add.w	d2,d2	
  addx.b	d4,d4
  add.w	d1,d1	
  addx.b	d4,d4
  add.w	d0,d0	
  addx.b	d4,d4
  and.w	#$f,d4	; In case of shitty bits.
  move.b	(a2)+,d5	
  lsr.b	#$4,d5	
  sub.b	d5,d4	
  move.b	d4,(a3)+	
 endr

  movem.w	(a1)+,d0-d3
 rept	16
  add.w	d3,d3	
  addx.b	d4,d4	
  add.w	d2,d2	
  addx.b	d4,d4
  add.w	d1,d1	
  addx.b	d4,d4
  add.w	d0,d0	
  addx.b	d4,d4
  and.w	#$f,d4	; In case of shitty bits.
  move.b	(a2)+,d5	
  lsr.b	#$4,d5	
  sub.b	d5,d4	
  move.b	d4,(a3)+	
 endr

  movem.w	(a1)+,d0-d3
 rept	16
  add.w	d3,d3	
  addx.b	d4,d4	
  add.w	d2,d2	
  addx.b	d4,d4
  add.w	d1,d1	
  addx.b	d4,d4
  add.w	d0,d0	
  addx.b	d4,d4
  and.w	#$f,d4	; In case of shitty bits.
  move.b	(a2)+,d5	
  lsr.b	#$4,d5	
  sub.b	d5,d4	
  move.b	d4,(a3)+	
 endr

  movem.w	(a1)+,d0-d3
 rept	16
  add.w	d3,d3	
  addx.b	d4,d4	
  add.w	d2,d2	
  addx.b	d4,d4
  add.w	d1,d1	
  addx.b	d4,d4
  add.w	d0,d0	
  addx.b	d4,d4
  and.w	#$f,d4	; In case of shitty bits.
  move.b	(a2)+,d5	
  lsr.b	#$4,d5	
  sub.b	d5,d4	
  move.b	d4,(a3)+	
 endr

  movem.w	(a1)+,d0-d3
 rept	16
  add.w	d3,d3	
  addx.b	d4,d4	
  add.w	d2,d2	
  addx.b	d4,d4
  add.w	d1,d1	
  addx.b	d4,d4
  add.w	d0,d0	
  addx.b	d4,d4
  and.w	#$f,d4	; In case of shitty bits.
  move.b	(a2)+,d5	
  lsr.b	#$4,d5	
  sub.b	d5,d4	
  move.b	d4,(a3)+	
 endr

  dbra	d6,.one_line2	; Ok, we have converted one line.

  movem.l	(sp)+,d0-d6/a0-a4 ; Try to erase this line...
  rts
;**************************************************************************

;**************************************************************************
  Section DATA

morph_images:
  incbin	'a:\morph.xxx'
morph_colors:
N set 0
 rept	8
  dc.w	N,N+$888
N set N+$111
 endr

;**************************************************************************
  Section BSS

black_image:
  ds.b  	48*size_y

linear_image:		; Some space for the linear image.
  ds.b	96*size_y
increments:		; And for the increments.
  ds.b	96*size_y
gem_colors:
  ds.w	16
gem_res:
  ds.w	1
