super_user:
 clr.l	-(sp)
 move.w	#$20,-(sp)
 trap	#1
 addq.l	#6,sp

 move.w	#$2700,sr

 move.l	#$ffff,a6
repeat:
 move.w	#$1,d0
 move.w	#$1,d1
 move.w	#$b0,d2
 move.w	#$1,d3
 move.l	#$f8000,a0
 jsr	fastline
 subq.l	#$1,a6
 cmp.l	#$0,a6
 bne	repeat

 move.w	#$2300,sr

 clr.w	-(sp)
 trap	#1



;****************************
; Line Routine en 1 bitplan.
;****************************

fastline:
; movem.w	d4-d6,-(sp)	; Il faut sauver les registres utilises.
 sub.w	d0,d2	; d2=dx=x2-x1.
 beq	v_line	; Ligne verticale?
 bmi.s	no_change	; On cheche a avoir x2<x1.
 add.w	d2,d0	; Si x1<x2 on change l'ordre.
 exg.l	d1,d3	; y1 et y2 echanges.
 neg.w	d2	; Deux negations pour avoir dx positif.
no_change:
 neg.w	d2	; Ici on a dx positif.
 move.l	#$a0,d4	; d4=sy=160 octets.
 sub.w	d1,d3	; d3=dy=y2-y1.
 beq	h_line	; Ligne horizontale?
 bge.s	dypos	; On calcule le signe de dy.
 neg.l	d4	; Si dy negatif on doit changer
 neg.w	d3	; le signe de sy et prendre d3=abs(dy).
dypos:
 move.w	d1,d5	; Calcul de l'adresse de depart.
 lsl.w	#$2,d1	; On multiplie y1 par 160.
 add.w	d5,d1	; Mais en evitant le mulu.
 lsl.w	#$5,d1
 add.w	d1,a0
 move.w	d0,d1	; On pense ensuite que la ram_video
 andi.w	#$fff0,d1	; est organise en mots.
 sub.w	d1,d0	; d0=x1 mod(16).
 lsr.w	#$1,d1	; d1=nbre de mots avant le point.
 add.l	d1,a0	; a0 est maintenant la bonne adresse.

 sub.w	#$f,d0	; On cherche maintenant le motif du
 neg.w	d0	; pixel de depart, et on le met dans d1.
 moveq.l	#$0,d1
 bset.l	d0,d1	; C'est fait.

calcul_slope:
 cmp.w	d3,d2	; Pente forte ou faible?
 bmi	big_slope	

;***********************
; dx>=dy  Pente faible.
;***********************

low_slope:
 move.w	d2,d5	; d5=dx=nbre de points.
 add.w	d3,d3	; d3=2*dy.
 move.w	d3,d6	; d6 utilise comme erreur.
 sub.w	d2,d6	; d6=2*dy-dx au depart.
 add.w	d2,d2	; d2=2*dx.
 move.w	(a0),d0	; On prend le mot sur lequel on travaille.
 or.w	d1,d0	; On affiche le premier point.
 subq.w	#$1,d5	; Et on enleve un au nbr de points qui restent.

low_line:
 tst.w	d6	; On regarde si l'erreur est positive.
 bpl.s	low_epos	; Si oui, y suivant.
low_eneg:		; Sinon, x suivant.
 add.w	d3,d6	; Erreur=d6+2*dy.
 add.w	d1,d1	; Motif du point suivant.
 beq	low_xnul	; Doit on changer de mot?
low_plot:
 or.w	d1,d0	; Affichage du point dans le registre de travail.
 dbra	d5,low_line	; On passe au point suivant.
 move.w	d0,(a0)	; Affichage du dernier mot.
; move.w	a0,(a6)+	; On sauve l'adresse des mots changes.
; addq.l	#$1,d7	; Et on les compte.
; movem.w	(sp)+,d4-d6	; On restaure les registres.
 rts		; Ligne affichee!..

low_epos:		; On doit changer de ligne.
 sub.w	d2,d6	; Erreur=d6-2*dx.
 move.w	d0,(a0)	; Affichage du mot.
; move.w	a0,(a6)+	; On sauve l'adresse des mots changes.
; addq.l	#$1,d7	; Et on les compte.
 add.l	d4,a0	; y=y+sy.
 move.w	(a0),d0	; Nouveau mot de travail.
low_eneg2:		; Le point suivant est sur x obligatoirement.
 add.w	d3,d6	; E=E+2*dy.
 add.w	d1,d1	; Motif du point suivant.
 beq	low_xnul	; Mot suivant?
low_plot2:
 or.w	d1,d0	; Affichage du point dans le registre de travail.
 dbra	d5,low_line	; On passe au point suivant.
 move.w	d0,(a0)	; Affichage du dernier mot.
; move.w	a0,(a6)+	; On sauve l'adresse des mots changes.
; addq.l	#$1,d7	; Et on les compte.
; movem.w	(sp)+,d4-d6	; On restaure les registres.
 rts		; Ligne affichee!..

low_xnul:		; On doit passer au mot suivant.
 move.w	d0,(a0)	; Affichage dans la ramvideo.
; move.w	a0,(a6)+	; On sauve l'adresse des mots changes.
; addq.l	#$1,d7	; Et on les compte.
 moveq.l	#$1,d1	; Motif du premier point.
 subq.l	#$8,a0	; Mot precedent.
 move.w	(a0),d0	; Que l'on met dans le registre.
low_plot3:
 or.w	d1,d0	; Affichage du point dans le registre de travail.
 dbra	d5,low_line	; On passe au point suivant.
 move.w	d0,(a0)	; Affichage du dernier mot.
; move.w	a0,(a6)+	; On sauve l'adresse des mots changes.
; addq.l	#$1,d7	; Et on les compte.
; movem.w	(sp)+,d4-d6	; On restaure les registres.
 rts		; Ligne affichee!..

;*********************
; dy>dx  Pente forte.
;*********************

big_slope:
 move.w	d3,d5	; d5=dy=nbre de points
 add.w	d2,d2	; d2=2*dx.
 move.w	d2,d6	; d6=Erreur.
 sub.w	d3,d6	; d6=2*dx-dy.
 add.w	d3,d3	; d3=2*dy
; and.l	#$ffff,d3	; Un point=un mot change,
; add.l	d3,d7	; on ajoute donc d5 a d7.

 or.w	d1,(a0)	; Affichage du premier point.
 subq.w	#$1,d5	; Un point de moins a afficher.

big_line:
 tst.w	d6	; Erreur positive?
 bpl.s	big_epos	; Si oui, x suivant.
big_eneg:		; Sinon, y suivant.
 add.w	d2,d6	; E=E+2*dx.
 add.l	d4,a0	; Adresse de la ligne suivante.
big_plot:
 or.w	d1,(a0)	; Affichage du point.
; move.w	a0,(a6)+	; On sauve l'adresse du mot change.
 dbra	d5,big_line	; Point suivant.
; movem.w	(sp)+,d4-d6	; On restaure les registres.
 rts		; Ligne affichee.

big_epos:
 sub.w	d3,d6	; E=E-2*dy.
 add.w	d1,d1	; Motif du point suivant.
 beq.s	big_xnul	; Doit on passer au mot precedent.
big_eneg2:		; Le point suivant est sur y.
 add.w	d2,d6	; E=E+2*dx.
 add.l	d4,a0	; y=y+sy.
big_plot2:
 or.w	d1,(a0)	; Affichage du point.
; move.w	a0,(a6)+	; Sauvegarde de l'adresse.
 dbra	d5,big_line	; Point suivant.
; movem.w	(sp)+,d4-d6	; Registres restaures.
 rts		; Fin de la ligne.

big_xnul:		; Passage au mot precedent.
 moveq.l	#$1,d1	; Motif du point de depart.
 subq.l	#$8,a0	; Mot precedent.
big_eneg3:		; Le point suivant est sur y.
 add.w	d2,d6	; E=E+2*dx.
 add.l	d4,a0	; y=y+sy.
big_plot3:
 or.w	d1,(a0)	; Affichage du point.
; move.w	a0,(a6)+	; Sauvegarde de l'adresse.
 dbra	d5,big_line	; Point suivant.
; movem.w	(sp)+,d4-d6	; Registres restaures.
 rts		; Fin de la ligne.


;*************************
; x1=x2  Ligne Verticale.
;*************************

v_line:
 move.l	#$a0,d4	; d4=sy.
 sub.w	d1,d3	; d3=dy.
 beq.s	single_dot	; Si dy=0 on a un point.
 bge.s	v_dypos	; Si dy>0 tout est ok.
 neg.l	d4	; Sinon on doit changer le signe de d4,
 neg.w	d3	; et prendre abs(dy).
v_dypos:
 move.w	d1,d5	; Multiplication de y1 par 160.
 lsl.w	#$2,d1
 add.w	d5,d1
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur le debut de la ligne.
 move.w	d0,d1	; Ensuite on recherche le mot de depart.
 andi.w	#$fff0,d1	; d1=x-x mod(16).
 sub.w	d1,d0	; d0=x mod(16).
 lsr.w	#$1,d1	; nbre de mots avant le x courant.
 add.w	d1,a0	; a0 point sur le bon mot.
 sub.w	#$f,d0	; On prend maintenant 15-x dans d0, car le
 neg.w	d0	; shifter lit d'abord les bits de poid fort.
 moveq.l	#$0,d1	; d1 va contenir le motif.
 bset.l	d0,d1	; Il le contient!

; andi.l	#$ffff,d3	; On clear le upperword.
; add.l	d3,d7 	; Nbre de mots modifies.
 subq.w	#$1,d3	; A cause du dbra.
v_one_line:
 or.w	d1,(a0)	; On affiche le motif.
; move.w	a0,(a6)+	; On sauve l'adresse.
 add.w	d4,a0	; Ligne suivante ou precedente.
 dbra	d3,v_one_line
; movem.w	(sp)+,d4-d6	; Registres restaures.
 rts		; Fin de la ligne.

single_dot:
 move.w	d1,d5	; Multiplication de y1 par 160.
 lsl.w	#$2,d1
 add.w	d5,d1
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur le debut de la ligne.
 move.w	d0,d1	; Ensuite on recherche le mot de depart.
 andi.w	#$fff0,d1	; d1=x-x mod(16).
 sub.w	d1,d0	; d0=x mod(16).
 lsr.w	#$1,d1	; nbre de mots avant le x courant.
 add.w	d1,a0	; a0 point sur le bon mot.
 sub.w	#$f,d0	; On prend maintenant 15-x dans d0, car le
 neg.w	d0	; shifter lit d'abord les bits de poid fort.
 moveq.l	#$0,d1	; d1 va contenir le motif.
 bset.l	d0,d1	; Il le contient!
 or.w	d1,(a0)	; Affichage du motif.
; move.w	a0,(a6)+	; On sauve l'adresse.
; addq.l	#$1,d7	; Et un mot de plus.
; movem.w	(sp)+,d4-d6	; Registres restaures.
 rts		; Fin de la ligne.


;***************************
; y1=y2  Ligne Horizontale.
;***************************

h_line:
 sub.w	d2,d0	; On retrouve x1.
 add.w	d0,d2	; Puis on retrouve x2.
 move.w	d1,d5	; Multiplication de y1 par 160.
 lsl.w	#$2,d1
 add.w	d5,d1
 lsl.w	#$5,d1
 add.w	d1,a0	; a0 pointe sur le debut de la ligne.

 moveq.l	#$0f,d4	; d4 sert pour les and.
 move.w	d0,d1	; Maintenant on va rechercher l'adresse de
 move.w	d2,d3	; depart ainsi que les motifs.
 and.w	d4,d0	; d0=x1 mod(16).
 and.w	d4,d2	; d2=x2 mod(16).
 sub.w	d0,d1	; d1=x1-x1 mod(16).
 sub.w	d2,d3	; d3=x2-x2 mod(16).
 lsr.w	#$1,d1	; d1=nbr de bytes avant motif de depart.
 lsr.w	#$1,d3	; d1=nbr de bytes avant motif d'arrivee.
 add.w	d1,a0	; a0 pointe sur le mot de depart.
 lsl.w	#$1,d0	; Un motif tient sur un mot.
 lsl.w	#$1,d2	; On va avoir le motif de depart dans d0
 move.l	#motifs,a1	; et celui d'arrivee dans d2.
 move.w	(a1,d0.w),d0
 move.w	(a1,d2.w),d2
 not.w	d0	; Inverser d2.
 sub.w	d1,d3	; Nombre de mots a afficher.
 beq.s	h_melted
 lsr.w	#$3,d3	; On utilise un seul bitplan.
 subq.w	#$2,d3	; Les mots extremes sont traites differement.
 bmi.s	h_near
h_far:
 move.l	#$ffff,d5	; Motif de remplissage.
; andi.l	d5,d3	; Nbre de mots modifies moins un.
; add.l	d3,d7	; On les comptabilises.
; addq.l	#$1,d7	; Tous!
 or.w	d0,(a0)	; Affichage du motif droit.
; move.w	a0,(a6)+	; Sauvegarde de l'adresse.
 addq.l	#$8,a0	; Mot suivant.
h_fill:
 move.w	d5,(a0)	
; move.w	a0,(a6)+	; Sauvegarde de l'adresse.
 addq.l	#$8,a0	; Mot suivant.
 dbra	d3,h_fill
 or.w	d2,(a0)	; Affichage du motif droit.
; move.w	a0,(a6)+	; Sauvegarde de l'adresse.
; movem.w	(sp)+,d4-d6	; Registres restaures.
 rts		; Fin de la ligne.

h_melted:
 and.w	d0,d2	; Motifs melanges.
 or.w	d2,(a0)	; affichage du motif.
; addq.l	#$1,d7	; Un mot de plus.
; move.w	a0,(a6)+	; Sauvegarde de l'adresse.
; movem.w	(sp)+,d4-d6	; Registres restaures.
 rts		; Fin de la ligne.

h_near:
; addq.l	#$2,d7	; Deux mots modifies.
 or.w	d0,(a0)	; Affichage du motif droit.
; move.w	a0,(a6)+	; Sauvegarde de l'adresse.
 addq.l	#$8,a0	; Mot suivant.
 or.w	d2,(a0)	; Affichage du motif droit.
; move.w	a0,(a6)+	; Sauvegarde de l'adresse.
; movem.w	(sp)+,d4-d6	; Registres restaures.
 rts		; Fin de la ligne.


motifs:
 dc.w	%1000000000000000
 dc.w	%1100000000000000
 dc.w	%1110000000000000
 dc.w	%1111000000000000
 dc.w	%1111100000000000
 dc.w	%1111110000000000
 dc.w	%1111111000000000
 dc.w	%1111111100000000
 dc.w	%1111111110000000
 dc.w	%1111111111000000
 dc.w	%1111111111100000
 dc.w	%1111111111110000
 dc.w	%1111111111111000
 dc.w	%1111111111111100
 dc.w	%1111111111111110
 dc.w	%1111111111111111
